#------------------------------------------------------------------------
#
#   IBM Software
#   Licensed Material - Property of IBM
#   (C) Copyright International Business Machines Corp. 2003, 2017
#   All Rights Reserved.
#
#   U.S. Government Users Restricted Rights - Use, duplication or
#   disclosure restricted by GSA ADP Schedule Contract with
#   IBM Corp.
#
#------------------------------------------------------------------------
#  tcl_utils.tcl
#
#  Generally useful tcl routines
#------------------------------------------------------------------------

#
# Returns 1 if we added to list and 0 if not
#
proc ListPushUnique {listname item} {

    # if it is not a namespace reference it must be global
    if { [string first "::" $listname] == -1 } {
        global $listname
    }

    if { [info exists $listname] == 1 } {
        eval "set thelist $$listname"
        if { [lsearch -exact $thelist $item] == -1 } {
            lappend $listname $item
        } else {
            return 0
        }
    } else {
        lappend $listname $item
    }
    return 1
}

proc SortedListPushUnique {listname item} {
    if { [string first "::" $listname] == -1 } {
        global $listname
    }
    if { [info exists $listname] == 1 } {
        eval "set thelist $$listname"
        if { [lsearch -exact $thelist $item] == -1 } {
            lappend $listname $item
        } else {
            return 0
        }
    } else {
        lappend $listname $item
    }
    set $listname [eval "lsort $$listname"]
    return 1
}

proc memsize_toint { memsize } {
    array set suffix_val {K 1024 M 1024*1024 G 1024*1024*1024}
    set retval 0
    if {[regexp {((0x)?\d+)([kKmMgG]?)} $memsize match digits hex suffix]} {
        if {[string length $suffix] == 0} {
            set retval $digits
        } else {
            set retval [expr $digits * $suffix_val([string toupper $suffix])]
        }
    }
    return $retval
}
