#------------------------------------------------------------------------
#
#   IBM Software
#   Licensed Material - Property of IBM
#   (C) Copyright International Business Machines Corp. 2003, 2017
#   All Rights Reserved.
#
#   U.S. Government Users Restricted Rights - Use, duplication or
#   disclosure restricted by GSA ADP Schedule Contract with
#   IBM Corp.
#
#------------------------------------------------------------------------
#  bogus_disk.tcl
#
#------------------------------------------------------------------------

namespace eval BogusDisk {}

#------------------------------------------------------------------------
#  BogusToolsDisk::init
#       This is a temporary namespace that will be removed soon. 1-30-2004.
#------------------------------------------------------------------------
namespace eval BogusToolsDisk {
    proc init { sim } {
        return [ BogusDisk::init $sim 0 tools_disk ]
    }
}

#------------------------------------------------------------------------
#  BogusDisk::init
#------------------------------------------------------------------------
proc BogusDisk::init { simulator device_number disk_name {mode "rw"} {disk_name_cow ""} } {

    if { $disk_name_cow == "" } then {
        append disk_name_cow "$disk_name" "_cow"
    }

    if { [ file exists $disk_name ] } then {
        switch -- $mode {
            "restcow"   -
            "newcow"    -
            "cow"       { $simulator bogus disk init $device_number $disk_name $mode $disk_name_cow 1024 }
            "default"   { $simulator bogus disk init $device_number $disk_name $mode }
        }
    }
}

#------------------------------------------------------------------------
#  BogusDisk::help_autoload
#       Auto register help commands associated with this file
#------------------------------------------------------------------------
proc BogusDisk::help_autoload {} {

    register_help_command "BogusDisk::init" "Initialize the bogus disk"

}


